extends MultiMeshInstance3D

const SPEED: float = 5.0

var directions: Array[int]

func _ready():
	directions.resize(multimesh.instance_count)
	for i in multimesh.instance_count:
		directions[i] = 1 if i % 2 == 0 else -1

func _physics_process(delta: float) -> void:
	for i in multimesh.instance_count:
		var xform = multimesh.get_instance_transform(i)
		if abs(xform.origin.y) > 4:
			directions[i] *= -1
		xform = xform.translated(Vector3.UP * SPEED * directions[i] * delta)
		multimesh.set_instance_transform(i, xform)
		var col = multimesh.get_instance_color(i)
		col[i % 3] += directions[i] * delta
		multimesh.set_instance_color(i, col)
	
	print(multimesh.get_instance_transform(0).origin)
